<?php
/**
 * @package MobileDE
 */
class SearchDE_Widget extends WP_Widget {

	var $mob_data;

	function SearchDE_Widget() {
		global $mob_data;
		$this->mob_data=$mob_data;

		parent::__construct(
			'mobileDE_widget',
			__( 'mobile.de Fahrzeugsuche' ),
			array( 'description' => __( 'Ihr Fahrzeugbestand von mobile.de' ) )
		);
	}

	// widget form creation
	function form( $instance ) {
		static $ic=0;

		if ( $instance ) {
			$title = esc_attr( $instance['title'] );
		}
		else {
			$title = __( 'Fahrzeugsuche' );
		}

?>
<script>
var classes={};
var brands={};
var models={};
var categories={};

<?php foreach($this->mob_data['classes'] as $classKey => $className): ?>
classes['<?=$classKey?>']='<?=$className?>';

if(brands['<?=$classKey?>']==null) {
	brands['<?=$classKey?>']={};
}
if(models['<?=$classKey?>']==null) {
	models['<?=$classKey?>']={};
}
<?php if(!empty($this->mob_data['brands'][$classKey])):foreach($this->mob_data['brands'][$classKey] as $brandKey => $brandName): ?>

brands['<?=$classKey?>']['<?=$brandKey?>']='<?=$brandName?>';
if(models['<?=$classKey?>']['<?=$brandKey?>']==null) {
	models['<?=$classKey?>']['<?=$brandKey?>']={};
}
<?php if(!empty($this->mob_data['models'][$classKey][$brandKey])):foreach($this->mob_data['models'][$classKey][$brandKey] as $modelKey => $modelName): ?>

models['<?=$classKey?>']['<?=$brandKey?>']['<?=$modelKey?>']='<?=$modelName?>';
<?php endforeach;endif; ?>
<?php endforeach;endif; ?>
if(categories['<?=$classKey?>']==null) {
	categories['<?=$classKey?>']={};
}
<?php if(!empty($this->mob_data['categories'][$classKey])):foreach($this->mob_data['categories'][$classKey] as $categoryKey => $categoryName): ?>

categories['<?=$classKey?>']['<?=$categoryKey?>']='<?=$categoryName?>';
<?php endforeach;endif; ?>
<?php endforeach;?>

class_list=[];
<?php if(!empty($instance['class_list'])):foreach($instance['class_list'] as $i => $classKey): ?>
class_list[<?=$i?>]='<?=$classKey?>';
<?php endforeach;endif; ?>

category_list=[];
<?php if(!empty($instance['category_list'])):foreach($instance['category_list'] as $i => $categoryKey): ?>
category_list[<?=$i?>]='<?=$categoryKey?>';
<?php endforeach;endif; ?>

brand_list=[];
<?php if(!empty($instance['brand_list'])):foreach($instance['brand_list'] as $i => $brandKey): ?>
brand_list[<?=$i?>]='<?=$brandKey?>';
<?php endforeach;endif; ?>

model_list=[];
<?php if(!empty($instance['model_list'])):foreach($instance['model_list'] as $i => $modelKey): ?>
model_list[<?=$i?>]='<?=$modelKey?>';
<?php endforeach;endif; ?>

jQuery(document).ready(function() {
	jQuery('.preselectToggle').click(function() {
		elem=jQuery(this).next('select');

		if(elem.css('display')=='none') {
			elem.css('display', 'block');
		} else {
			elem.css('display', 'none');
		}
	});

	var classesHtml='';
	for(value in classes) {
		name=classes[value];

		var selected='';
		if(class_list.indexOf(value) != -1) {
			selected='selected="selected" ';
		}
		classesHtml+='<option '+selected+'value="'+value+'">'+name+'</option>';
	}
	jQuery('.mob_class').html(classesHtml);
	jQuery('.mob_class').trigger('change');

	jQuery('body').on('change', '.mob_class', function() {

		//populate categories and brands
		brandsHtml='';
		categoriesHtml='';

		jQuery(this).find('option:selected').each(function() {	

			brandsInClass=brands[jQuery(this).attr('value')];
			for(i in brandsInClass) {
				value=jQuery(this).attr('value')+'::'+i;

				var selected='';
				if(brand_list.indexOf(value) != -1) {
					selected='selected="selected" ';
				}
				brandsHtml+='<option '+selected+'value="'+value+'">'+brandsInClass[i]+'</option>';
			}
			
			categoriesInClass=categories[jQuery(this).attr('value')];
			for(i in categoriesInClass) {
				var value = jQuery(this).attr('value')+'::'+i;
				var selected='';
				if(category_list.indexOf(value) != -1) {
					selected='selected="selected" ';
				}
				categoriesHtml+='<option '+selected+'value="'+value+'">'+categoriesInClass[i]+'</option>';
			}
		});

		jQuery('.mob_brand').html(brandsHtml);
		jQuery('.mob_category').html(categoriesHtml);

		jQuery('.mob_brand').trigger('change');
		jQuery('.mob_category').trigger('change');

	});

	jQuery('body').on('change', '.mob_brand', function() {
		//populate models
		modelsHtml='';
			
		jQuery(this).find('option:selected').each(function() {	

			key=jQuery(this).attr('value').split('::');
			modelsInClass=models[key[0]][key[1]];
			for(i in modelsInClass) {
				var value = jQuery(this).attr('value')+'::'+i;

				var selected='';
				if(model_list.indexOf(value) != -1) {
					selected='selected="selected" ';
				}
				modelsHtml+='<option '+selected+'value="'+value+'">'+modelsInClass[i]+'</option>';
			}
		});

		jQuery('.mob_model').html(modelsHtml);
		jQuery('.mob_model').trigger('change');

	});
});
</script>
		<p>
		<label for="<?php echo $this->get_field_id( 'title' ); ?>"><?php _e( 'Title:' ); ?></label> 
		<input class="widefat" id="<?php echo $this->get_field_id( 'title' ); ?>" name="<?php echo $this->get_field_name( 'title' ); ?>" type="text" value="<?php echo $title; ?>" />
		</p><p>Anzuzeigende Felder:</p>

		<div>
			<input class="preselectToggle mob_class<?=$ic?>" id="<?php echo $this->get_field_id('checkbox'); ?>" name="<?php echo $this->get_field_name('class'); ?>" type="checkbox" value="1" <?php checked( '1', esc_attr($instance['class']) ); ?> />
				
				Fahrzeugkategorie
				<select class="mob_class" id="class" name="<?php echo $this->get_field_name('class_list'); ?>[]" multiple="multiple" style="width:200px;">
</select>
				</div>
		<div>
			<input class="preselectToggle mob_brand<?=$ic?>" id="<?php echo $this->get_field_id('checkbox'); ?>" name="<?php echo $this->get_field_name('brand'); ?>" type="checkbox" value="1" <?php checked( '1', esc_attr($instance['brand']) ); ?> />
				
				Hersteller
<select class="mob_brand" rel="class" id="brand" name="<?php echo $this->get_field_name('brand_list'); ?>[]" multiple="multiple" style="width:200px;">
</select>
				</div>
		<div>
			<input class="preselectToggle model<?=$ic?>" id="<?php echo $this->get_field_id('checkbox'); ?>" name="<?php echo $this->get_field_name('model'); ?>[]" type="checkbox" value="1" <?php checked( '1', esc_attr($instance['model']) ); ?> />
				
				Modell
<select class="mob_model" rel="brand" id="model" name="<?php echo $this->get_field_name('model_list'); ?>[]" multiple="multiple" style="width:200px;">
</select>
				</div>
		<div>
			<input class="variant<?=$ic?>" id="<?php echo $this->get_field_id('checkbox'); ?>" name="<?php echo $this->get_field_name('variant'); ?>" type="checkbox" value="1" <?php checked( '1', esc_attr($instance['variant']) ); ?> />
				
				Modellvariante</div>
		<div>
			<input class="preselectToggle category<?=$ic?>" id="<?php echo $this->get_field_id('checkbox'); ?>" name="<?php echo $this->get_field_name('category'); ?>" type="checkbox" value="1" <?php checked( '1', esc_attr($instance['category']) ); ?> />
				
				Fahrzeugtyp
<select id="category" class="mob_category" rel="class" name="<?php echo $this->get_field_name('category_list'); ?>[]" multiple="multiple" style="width:200px;">
</select>
				</div>
		<div>
			<input id="<?php echo $this->get_field_id('checkbox'); ?>" name="<?php echo $this->get_field_name('registrationDate'); ?>" type="checkbox" value="1" <?php checked( '1', esc_attr($instance['registrationDate']) ); ?> />
			Erstzulassung</div>
		<div>
			<input id="<?php echo $this->get_field_id('checkbox'); ?>" name="<?php echo $this->get_field_name('owners'); ?>" type="checkbox" value="1" <?php checked( '1', esc_attr($instance['owners']) ); ?> />

				
				Besitzer</div>
		<div>
			<input id="<?php echo $this->get_field_id('checkbox'); ?>" name="<?php echo $this->get_field_name('mileage'); ?>" type="checkbox" value="1" <?php checked( '1', esc_attr($instance['mileage']) ); ?> />

				
				Laufleistung</div>
		<div>
			<input id="<?php echo $this->get_field_id('checkbox'); ?>" name="<?php echo $this->get_field_name('monthsTillInspection'); ?>" type="checkbox" value="1" <?php checked( '1', esc_attr($instance['monthsTillInspection']) ); ?> />

				
				TÜV</div>
		<div>
			<input id="<?php echo $this->get_field_id('checkbox'); ?>" name="<?php echo $this->get_field_name('power'); ?>" type="checkbox" value="1" <?php checked( '1', esc_attr($instance['power']) ); ?> />

				
				Leistung</div>
		<div>
			<input id="<?php echo $this->get_field_id('checkbox'); ?>" name="<?php echo $this->get_field_name('cubicCapacity'); ?>" type="checkbox" value="1" <?php checked( '1', esc_attr($instance['cubicCapacity']) ); ?> />

				
				Hubraum</div>
		<div>
			<input id="<?php echo $this->get_field_id('checkbox'); ?>" name="<?php echo $this->get_field_name('price'); ?>" type="checkbox" value="1" <?php checked( '1', esc_attr($instance['price']) ); ?> />

				
				Preis</div>
		
			
		<div>
			<input id="<?php echo $this->get_field_id('checkbox'); ?>" name="<?php echo $this->get_field_name('fuel'); ?>" type="checkbox" value="1" <?php checked( '1', esc_attr($instance['fuel']) ); ?> />

				
				Kraftstoff</div>
		<div>
			<input id="<?php echo $this->get_field_id('checkbox'); ?>" name="<?php echo $this->get_field_name('gearbox'); ?>" type="checkbox" value="1" <?php checked( '1', esc_attr($instance['gearbox']) ); ?> />

				
				Getriebe</div>
		<div>
			<input id="<?php echo $this->get_field_id('checkbox'); ?>" name="<?php echo $this->get_field_name('damaged'); ?>" type="checkbox" value="1" <?php checked( '1', esc_attr($instance['damaged']) ); ?> />

				
				Beschädigt</div>
		<div>
			<input id="<?php echo $this->get_field_id('checkbox'); ?>" name="<?php echo $this->get_field_name('readyToDrive'); ?>" type="checkbox" value="1" <?php checked( '1', esc_attr($instance['readyToDrive']) ); ?> />

				
				Fahrbereit</div>
		<div>
				
				Ergebnisse sortieren nach


</select>
				</div>
				
				<?php
				
				$ic++;
	}

	// widget update
	function update( $new_instance, $old_instance ) {
		$instance = $new_instance;

		$instance['title'] = strip_tags($new_instance['title']);
		$instance['category'] = strip_tags($new_instance['category']);
		$instance['class'] = strip_tags($new_instance['class']); 
		$instance['brand'] = strip_tags($new_instance['brand']);
		$instance['model'] = strip_tags($new_instance['model']);
		$instance['variant'] = strip_tags($new_instance['variant']);

		$instance['class_list'] = ($new_instance['class_list']);
		$instance['brand_list'] = ($new_instance['brand_list']);
		$instance['model_list'] = ($new_instance['model_list']);
		$instance['category_list'] = ($new_instance['category_list']);

		$instance['registrationDate'] = strip_tags($new_instance['registrationDate']);
		$instance['owners'] = strip_tags($new_instance['owners']);
		$instance['mileage'] = strip_tags($new_instance['mileage']);
		$instance['monthsTillInspection'] = strip_tags($new_instance['monthsTillInspection']);
		$instance['power'] = strip_tags($new_instance['power']);
		$instance['cubicCapacity'] = strip_tags($new_instance['cubicCapacity']);
		$instance['price'] = strip_tags($new_instance['price']);
		$instance['VAT'] = strip_tags($new_instance['VAT']);
		$instance['fuel'] = strip_tags($new_instance['fuel']);
		$instance['gearbox'] = strip_tags($new_instance['gearbox']);
		$instance['damaged'] = strip_tags($new_instance['damaged']);
		$instance['readyToDrive'] = strip_tags($new_instance['readyToDrive']);
		$instance['orderby'] = strip_tags($new_instance['orderby']); 


	    return $instance;
	}

	// widget display
	function widget($args, $instance) {

	   extract( $args );
	   
	   $title = apply_filters('widget_title', $instance['title']);

	   echo $before_widget;
	   // Display the widget
	   echo '<div class="widget-text wp_widget_plugin_box">';
	 
	   // Check if title is set
	   if ( $title ) {
	      echo $before_title . $title . $after_title;
	   }
	 
		include_once 'template/widget_form.php';

	   echo '</div>';
	   echo $after_widget;
	}
}

// register widget
function load_widget(){
	return register_widget("SearchDE_Widget");
}
add_action('widgets_init', 'load_widget');


/* Widget search handler */
add_action( 'pre_get_posts', 'mobileDE_extended_search' );
function mobileDE_extended_search( $query )
{
	global $mob_data;
    // Make sure we got a search query
    // and we're only modifying the main query.
    if (
        ! $query->is_main_query()
      
      
    ) {
        return $query;
	}else {

		$cond=array();
		
		if(!empty($_GET['mob_category'])){
		    $cond[]=array(
				'key'     => 'category_key',
				'value'   => $_GET['mob_category'],
				'compare' => '='
			);
		}
		
		//add search per classes, brand, models, variant (model description)
		if(!empty($_GET['mob_class'])){
		    $cond[]=array(
				'key'     => 'class_key',
				'value'   => $_GET['mob_class'],
				'compare' => '='
			);

			if(!empty($_GET['mob_brand'])){
				$cond[]=array(
					'key'     => 'brand_key',
					'value'   => $_GET['mob_brand'],
					'compare' => '='
				);
				if(!empty($_GET['mob_model'])){
					$cond[]=array(
						'key'     => 'model_key',
						'value'   => $_GET['mob_model'],
						'compare' => '='
					);
				}
				if(!empty($_GET['mob_variant'])){
					$cond[]=array(
						'key'     => 'variant',
						'value'   => $_GET['mob_variant'],
						'compare' => '='
					);
				}
			}
		}

		if(!empty($_GET['mob_firstRegistrationDateMin'])){
			$cond[]=array(
				'key'     => 'firstRegistration',
				'value'   => $_GET['mob_firstRegistrationDateMin'].'-01',
				'type'    => 'string',
				'compare' => '>='
			);
		}

		if(!empty($_GET['mob_firstRegistrationDateMax'])){
			$cond[]=array(
				'key'     => 'firstRegistration',
				'value'   => $_GET['mob_firstRegistrationDateMax'].'-12',
				'type'    => 'string',
				'compare' => '<='
			);
		}

		if(!empty($_GET['mob_owners'])){
			$cond[]=array(
				'key'     => 'owners_key',
				'value'   => $_GET['mob_owners'],
				'type'    => 'numeric',
				'compare' => '<='
			);
		}

		if(!empty($_GET['mob_mileageFrom'])){
			$cond[]=array(
				'key'     => 'mileage',
				'value'   => $_GET['mob_mileageFrom'],
				'type'    => 'numeric',
				'compare' => '>='
			);
		}

		if(!empty($_GET['mob_mileageTo'])){
			$cond[]=array(
				'key'     => 'mileage',
				'value'   => $_GET['mob_mileageTo'],
				'type'    => 'numeric',
				'compare' => '<='
			);
		}

		if(!empty($_GET['mob_monthsTillInspection'])){
			$cond[]=array(
				'key'     => 'monthsTillInspection',
				'value'   => $_GET['mob_monthsTillInspection'],
				'type'    => 'numeric',
				'compare' => '='
			);
		}

		if(!empty($_GET['mob_powerMin'])){
			$cond[]=array(
				'key'     => 'power_key',
				'value'   => $_GET['mob_powerMin'],
				'type'    => 'numeric',
				'compare' => '>='
			);
		}

		if(!empty($_GET['mob_powerMax'])){
			$cond[]=array(
				'key'     => 'power_key',
				'value'   => $_GET['mob_powerMax'],
				'type'    => 'numeric',
				'compare' => '<='
			);
		}

		if(!empty($_GET['mob_cubicCapacityMin'])){
			$cond[]=array(
				'key'     => 'cubicCapacity_key',
				'value'   => $_GET['mob_cubicCapacityMin'],
				'type'    => 'numeric',
				'compare' => '>='
			);
		}

		if(!empty($_GET['mob_cubicCapacityMax'])){
			$cond[]=array(
				'key'     => 'cubicCapacity_key',
				'value'   => $_GET['mob_cubicCapacityMax'],
				'type'    => 'numeric',
				'compare' => '<='
			);
		}

		if(!empty($_GET['mob_priceMin'])){
			$cond[]=array(
				'key'     => 'price',
				'value'   => $_GET['mob_priceMin'],
				'type'    => 'numeric',
				'compare' => '>='
			);
		}

		if(!empty($_GET['mob_priceMax'])){
			$cond[]=array(
				'key'     => 'price',
				'value'   => $_GET['mob_priceMax'],
				'type'    => 'numeric',
				'compare' => '<='
			);
		}

		if(!empty($_GET['mob_vatable'])){
			$cond[]=array(
				'key'     => 'vatable',
				'value'   => ($_GET['mob_vatable']=="true"?'true':'false'),
				'compare' => '='
			);
		}

		if(!empty($_GET['mob_fuel'])){
			if(is_array($_GET['mob_fuel'])){
				$_GET['mob_fuel']=implode(',',$_GET['mob_fuel']);
			}
			$cond[]=array(
				'key'     => 'fuel_key',
				'value'   => $_GET['mob_fuel'],
				'compare' => 'IN'
			);
		}

		if(!empty($_GET['mob_gearbox'])){
			$cond[]=array(
				'key'     => 'gearbox_key',
				'value'   => $_GET['mob_gearbox'],
				'compare' => '='
			);
		}

		if(!empty($_GET['mob_damageUnrepaired'])){
			$cond[]=array(
				'key'     => 'damageUnrepaired',
				'value'   => ($_GET['mob_damageUnrepaired']=="true"?'true':'false'),
				'compare' => '='
			);
		}

		if(!empty($_GET['mob_roadworthy'])){
			$cond[]=array(
				'key'     => 'roadworthy',
				'value'   => ($_GET['mob_roadworthy']=="true"?'true':'false'),
				'compare' => '='
			);
		}
		
		$query->set( 'meta_query', $cond);

		if(!empty($_GET['orderby'])) {
			$query->set( 'meta_key', $_GET['orderby'] );
			$query->set( 'orderby', 'meta_value_num');
			$query->set( 'order', 'ASC');
			$query->set( 'post_type', array('fahrzeuge'));
		} 

    return $query;
	}
}
